//
//  STELSOCK	(SSL Telnet Socket)
//
//	Copyright (C) 1997 NEC Corporation
//	All rights reserved.
//  Authos(s): Mizukoshi, Yasuhiro <mizukosi@ccs.mt.nec.co.jp>
//

//	    $Archive: /sotools/stelsock/socklist.c $
//			$Revision: 5 $
//			$Date: 97/05/29 4:41p $
static char VssID[] = "$Header: /sotools/stelsock/socklist.c 5     97/05/29 4:41p Mizukosi $";

//
//	Functions:
//		SocketListAlloc
//		SocketListAddTail
//		SocketListDelete
//		SocketListGetPos
//

#include	<windows.h>
#include	<winsock.h>
#include	<stdio.h>

#include	"ssl.h"
#include	"stelsock.h"
#include	"auth.h"
#include	"globals.h"


struct SocketList *gSockList;


///////////////////////////////////////////////////////////////////
//
// Allocate socket
//
struct SocketList *SocketListAlloc()
{
	return (struct SocketList *)malloc(sizeof(struct SocketList));
}


//////////////////////////////////////////////////////////////////
//
// Add socket to tail of socket list.
//
int SocketListAddTail(SOCKET s)
{
	struct SocketList *psl;

	if (gSockList == NULL){

		gSockList = SocketListAlloc();
		if (gSockList == NULL)
			return FALSE;

		gSockList->pPrev = NULL;
		gSockList->pNext = NULL;
		psl = gSockList;

	} else {

		psl = gSockList;

		while (psl->pNext != NULL)
			psl = psl->pNext;

		psl->pNext = SocketListAlloc();
		if (psl->pNext == NULL)
			return FALSE;

		psl->pNext->pPrev = psl;
		psl->pNext->pNext = NULL;
		psl = psl->pNext;
	}

	// socket as reference ID.
	psl->s = s;

	psl->iStat	      = SS_INIT;
	psl->bNonBlocking = FALSE;

	// Parameters for WSAAsyncSelect()
	psl->hAsyncWnd   = NULL;
	psl->uAsyncMsg   = 0;
	psl->lAsyncEvent = 0;

	// STelChk structure for SSLeay
	psl->STelChk.bSSLActive = FALSE;
	psl->STelChk.bInSSLCall = FALSE;
	psl->STelChk.con        = NULL;
	psl->STelChk.ctx        = NULL;

	return TRUE;
}


//////////////////////////////////////////////////////////////////
//
// Delete socket from socket list.
//
int SocketListDelete(SOCKET s)
{
	struct SocketList *psl;

	psl = gSockList;

	while (psl != NULL){
		if (psl->s == s){

			if (psl->STelChk.bSSLActive){
				SSL_free(psl->STelChk.con);
				psl->STelChk.bSSLActive = FALSE;
			}

			if (psl->pPrev == NULL && psl->pNext == NULL){
				gSockList = NULL;
			} else if (psl->pPrev == NULL){
				gSockList = psl->pNext;
				gSockList->pPrev = NULL;
			} else if (psl->pNext == NULL){
				psl->pPrev->pNext = NULL;
			} else {
				psl->pPrev->pNext = psl->pNext;
				psl->pNext->pPrev = psl->pPrev;
			}
			free(psl);

x_OutputDebugString("\nSUCCESS: Delete SocketList Struct\n");

			return TRUE;
		}
		psl = psl->pNext;
	}

x_OutputDebugString("\nFAILURE: Delete SocketList Struct\n");

	return FALSE;
}


//////////////////////////////////////////////////////////////////
//
// Get socket position by socket.
//
struct SocketList *SocketListGetPos(SOCKET s)
{
	struct SocketList *psl;

	psl = gSockList;

	while (psl != NULL){
		if (psl->s == s)
			return psl;
		psl = psl->pNext;
	}

	return NULL;
}


//////////////////////////////////////////////////////////////////
//
// Get socket position by stat.
//
struct SocketList *SocketListGetPosByStat(int iStat)
{
	struct SocketList *psl;

	psl = gSockList;

	while (psl != NULL){
		if (psl->iStat == iStat)
			return psl;
		psl = psl->pNext;
	}

	return NULL;
}
